/*
 * Support for ethernet hardware devices.
 * Copyright (C) 1998 Chris Csanady and Pete Wyckoff
 *
 * $Id: ether.h,v 1.1 1998/09/22 22:01:14 pw Exp $
 */
#ifndef _LIB_ETHER_H
#define _LIB_ETHER_H

#include "vivar.h"

#if defined(__GLIBC__) && __GLIBC__ >= 2
# include <netinet/ether.h>
#else
# define NEED_ETHER_COMPAT
struct ether_addr {
    u_int8_t ether_addr_octet[ETH_ALEN];
};
#endif

struct vi_net_address_ether {
    u_int16_t		HostAddressLen;
    u_int16_t		DiscriminatorLen;
    struct ether_addr	ea;	/* ethernet hardware address */
    u_int16_t		port;	/* svi or dvi/port */
};
#define VIP_ETHER_ADDRESS_LEN		(ETH_ALEN)
#define VIP_ETHER_DISCRIMINATOR_LEN	(sizeof(u_int16_t))

extern void VipAddressInitializeEther(struct vi_net_address_ether *a);

struct vi_bind_req_ether {
    int vi;
    struct vi_net_address_ether addr;
};

struct vi_getpeer_req_ether {
    int vi;
    struct vi_net_address_ether addr;
};

#endif  /* _LIB_ETHER_H */
