/*
 * Basic VI routines.
 * Copyright (C) 1998 Chris Csanady and Pete Wyckoff
 *
 * $Id: extern.h,v 1.3 1998/09/22 22:01:15 pw Exp $
 */
#include "vivar.h"

/* hardware connection */
extern VIP_RETURN VipOpenNic(const char *device_name, int *nic_handle_return);
extern VIP_RETURN VipCloseNic(int nic_handle);

/* endpoint creation */
extern VIP_RETURN VipCreateVi(int nic_handle, const struct vi_attribs *attr,
  int send_cq_handle, int recv_cq_handle, int *vi_handle_return);
extern VIP_RETURN VipDestroyVi(int vi_handle);

/* connection management */
extern VIP_RETURN VipConnectWait(int nic_handle,
  const struct vi_net_address *local_addr, unsigned long timeout,
  struct vi_net_address *remote_addr, struct vi_attribs *remote_attr,
  int *conn_handle_return);
extern VIP_RETURN VipConnectAccept(int conn_handle, int vi_handle);
extern VIP_RETURN VipConnectReject(int conn_handle);
extern VIP_RETURN VipConnectRequest(int vi_handle,
  const struct vi_net_address *local_addr,
  struct vi_net_address *remote_addr, unsigned long timeout,
  struct vi_attribs *remote_attr);
extern VIP_RETURN VipDisconnect(int vi_handle);

/* memory registration (no Ptags) */
extern VIP_RETURN VipRegisterMem(int nic_handle, void *va, unsigned long len,
  const struct vi_mem_attr *attr, int *mem_handle_return);
extern VIP_RETURN VipDeregisterMem(int nic_handle, const void *va,
  int mem_handle);

/* send/recv */
extern VIP_RETURN VipPostSend(int vi_handle, struct vi_cseg *desc,
  int mem_handle);
extern VIP_RETURN VipPostRecv(int vi_handle, struct vi_cseg *desc,
  int mem_handle);
extern VIP_RETURN VipSendDone(int vi_handle, struct vi_cseg **desc_return);
extern VIP_RETURN VipRecvDone(int vi_handle, struct vi_cseg **desc_return);
extern VIP_RETURN VipSendWait(int vi_handle, unsigned long timeout,
  struct vi_cseg **desc_return);
extern VIP_RETURN VipRecvWait(int vi_handle, unsigned long timeout,
  struct vi_cseg **desc_return);

/* nothing about completion queues, error handlers, etc. */

/* other handy extensions */
extern VIP_RETURN VipGetAddressByName(int nic_handle, const char *s,
  struct vi_net_address *addr);
