/*
 * Internal header for VIP library and hardware modules.
 * Copyright (C) 1998 Chris Csanady and Pete Wyckoff
 *
 * $Id: libvi.h,v 1.1 1998/09/22 22:03:39 pw Exp $
 */
#ifndef _LIB_LIBVI_H
#define _LIB_LIBVI_H

/*
 * Hardware functions, info.
 */
struct hardware_desc {
    hw_type type;
    VIP_RETURN (*listen)(int nic, int vi,
      const struct vi_net_address *local_addr);
    VIP_RETURN (*getpeerinfo)(int nic, int vi,
      const struct vi_net_address **remote_addr);
    VIP_RETURN (*bind)(int nic, int vi,
      const struct vi_net_address *remote_addr);
    VIP_RETURN (*lookup)(const char *name, struct vi_net_address *addr);
    int (*address_length)(void);
};

/*
 * Handy error routines for hardware modules.
 */
extern VIP_RETURN vi_verror(VIP_RETURN err, const char *fmt, ...);
extern void vi_warn(const char *fmt, ...);
extern VIP_RETURN vi_perror(const char *fmt, ...);

#endif  /* _LIB_LIBVI_H */
