/*
 * readkmem.c
 * Copyright (C) 1998 Chris Csanady and Pete Wyckoff
 */
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

main(int argc, char *argv[])
{
    int fd, i;
    FILE *fp;
    unsigned long addr;
    unsigned char b[1024];

    if (argc != 2) return 1;
    addr = strtoul(argv[1], NULL, 0);
    if (!(fd = open("/dev/kmem", O_RDONLY)) < 0) {
	perror("open kmem");
	return 1;
    }
#if 0
    if (lseek(fd, addr, SEEK_SET) == (unsigned long)-1) {
	perror("seek kmem");
	return 1;
    }
#else
    (void) lseek(fd, addr, SEEK_SET);
#endif
    if (read(fd, b, sizeof(b)) < 0) {
	perror("read kmem");
	return 1;
    }
    (void) close(fd);
    if (!(fp = fopen("x.c", "w"))) {
	perror("open x.c");
	return 1;
    }
    fprintf(fp, "unsigned char b[%d] = {\n", sizeof(b));
    for (i=0; i<sizeof(b); i++)
	fprintf(fp, "  %3u,\n", b[i]);
    fprintf(fp, "};\n");
    (void) fclose(fp);
    (void) system("gcc -c x.c -o x.o ; objdump --disassemble-all x.o");
    return 0;
}
