/* MP_Lite by Dave Turner - Ames Lab - Sept of 1997+
 * This file is for the scalar version which:
 *    - provides NULL stubs for all MP_Lite commands
 *      so that the codes can be run in scalar mode 
 */

#include "mplite.h"

void MP_Init() { myproc=0; nprocs=1; }
int MP_Nprocs(int* n) { *n = 1; return 1; } 
int MP_Myproc(int* m) { *m = 0; return 0; } 
void MP_Finalize() { }
void MP_Wait(int *msg_id) { }
void MP_Sync() {}

void MP_ASend(void *buf, int nbytes, int dest, int *msg_id)
{
   if( dest != 0 )
      printf("WARNING - MP_ASend() is trying to send to node %d"
             " in a serial run\n", dest);
}

void MP_Send(void *buf, int nbytes, int dest)
{
   if( dest != 0 )
      printf("WARNING - MP_Send() is trying to send to node %d"
             " in a serial run\n", dest);
}


void MP_ARecv(void *buf, int nbytes, int src, int *msg_id)
{
   if( src != 0 )
      printf("WARNING - MP_ARecv() is trying to receive from node %d"
             " in a serial run\n", src);
}

void MP_Recv(void *buf, int nbytes, int src)
{
   if( src != 0 )
      printf("WARNING - MP_Recv() is trying to receive from node %d"
             " in a serial run\n", src);
}

