#!/bin/sh

file=sizes.c
rm -f $file
exec 1>$file

cat << EOF
#include <stdio.h>
#define KERNEL 1
#ifdef __linux__
#include <sys/types.h>
extern void printk(char *fmt, ...);
struct sk_buff;  /* forward ref these things */
struct device;
#define __sizes_c
#endif  /* __linux__ */
#include "vivar.h"

#ifdef __alpha__
#  define FMT "%4ld"
#else
#  define FMT "%4d"
#endif

int
main(int argc, char *argv[])
{
    int i;
EOF

for i in `egrep '^struct.*{' ../lkm/vivar.h | cut -f2 -d\ `
do
    echo "    printf(\"%-20s \" FMT, \"$i\", sizeof(struct $i));"
    echo "    for (i = 2; i < sizeof(struct $i); i *= 2) ;"
    echo "    if (i != sizeof(struct $i)) printf(\" *\");"
    echo "    printf(\"\n\");"
done

echo "return 0; }"
exit 0
